### Attach to GoGui
1. cd into this alphazero directory
2. mkdir **./temp**
3. place **best.pth.tar** in **./temp**
4. on line 83 in **nogo_alphazero.py**, modify **size** to be the actual board size to play
5. attach **nogo_alphazero.py** to GoGui (set working directory to this alphazero directory)
6. (optional) on line 24 in nogo_alphazero.py, adjust **numSimsPerValidMove** for speed or strength
### Some features
1. multiprocessing - 4 cores
2. ResNet
<pre>
          conv2d
          resblock
          resblock
          conv2d
            fc (fully connected)
            fc
          /    \
        fc      fc
        |       |
      policy    v
</pre>
3. Design
<pre>
In one iteration:
      (*) 400 self-play games
            In one self-play game:
              * 75 mcts simulations per move
              * first 15 moves use probabilistic policy from mcts
              * 16th move and onwards play best move (argmax)
      (*) 20000 training examples will be sampled over all self-play games for this iteration
      (*) training examples from the latest 10 iterations preserved
      (*) 20000 * 10 examples feed into NN
            In NN:
              * 10 epochs
              * batch size = 64 randomly sampled
              * 20000 * 10 / 64 forward-and-backward's per epochs
              * lr = 0.001
      (*) 160 arena games between old and new
            In one arena game:
              * 25 mcts simulations per move
              * first 5 moves use probabilistic policy from mcts
              * 6th move and onwards play best move (argmax)
      (*) 55% wins against old version, accepting new model
</pre>
