from Coach import Coach
from nogo.NogoGame import NogoGame as Game
from nogo.pytorch.NNet import NNetWrapper as nn
from utils import *
import torch.multiprocessing as mp


args = dotdict({
    # 'numIters': 1000,
    'numIters': 500,
    'numEps': 400,              # Number of complete self-play games to simulate during a new iteration.
    'tempThreshold': 15,        #
    'dirichlet_alpha': 0.03,
    'eps': 0.25,
    'updateThreshold': 0.55,     # During arena playoff, new neural net will be accepted if threshold or more of games are won.
    'maxlenOfQueue': 20000,    # Number of game examples to train the neural networks.
    'numMCTSSims': 75,          # Number of games moves for MCTS to simulate.
    'arenaCompare': 160,         # Number of games to play during arena play to determine if new net will be accepted.
    'cpuct': 1,
    'numPs': 4,

    'checkpoint': './temp/',
    'load_model': False,
    'load_folder_file': ('./pretrained_models/nogo7x7','best.pth.tar'),
    'numItersForTrainExamplesHistory': 10,
})

if __name__ == "__main__":
    try:
        mp.set_start_method('spawn')
    except RuntimeError:
        print("torch.multiprocessing failed to set 'spawn' as start method")
    
    g = Game(7)     # 7
    nnet = nn(g)
    print("Load model =", args.load_model)

    if args.load_model:
        nnet.load_checkpoint(args.load_folder_file[0], args.load_folder_file[1])

    c = Coach(g, nnet, args)
    if args.load_model:
        print("Load trainExamples from file")
        c.loadTrainExamples()
    c.learn()
