from sys import stderr


class dotdict(dict):

    __setattr__ = dict.__setitem__
    __delattr__ = dict.__delitem__

    def __getattr__(self, attr):
        return self.get(attr)
    
    def __getstate__(self):
        return self
    
    def __setstate__(self, state):
        self.update(state)
        self.__dict__ = self


def print_pi(pi, size, label):
    lines = label + "\n"
    for r in reversed(range(size)):
        line = " ".join(["{:6.3f}".format(c*100) for c in pi[size*r:size*(r+1)]])
        lines = lines + line + "\n"
    lines += "\n"
    stderr.write(lines)
    stderr.flush()
